defmodule MicroservicesAuthorization.Token do
  alias Plug.Crypto
  alias Plug.Crypto.{KeyGenerator, MessageEncryptor}

  def generate_token(data) do
    MessageEncryptor.encrypt(
      %{data: data} |> :erlang.term_to_binary(),
      get_secret(),
      get_sign_secret()
    )
  end

  def decode_token(token) do
    case MessageEncryptor.decrypt(
           token,
           get_secret(),
           get_sign_secret()
         ) do
      {:ok, binary_data} ->
        %{data: data} = Crypto.safe_binary_to_term(binary_data)
        data

      _ ->
        :error
    end
  end

  defp get_secret do
    secret_key_base = "072d1e0157c008193fe48a670cce031faa4e"
    encrypted_cookie_salt = "encrypted cookie"
    KeyGenerator.generate(secret_key_base, encrypted_cookie_salt)
  end

  defp get_sign_secret do
    secret_key_base = "072d1e0157c008193fe48a670cce031faa4e"
    encrypted_signed_cookie_salt = "signed encrypted cookie"

    KeyGenerator.generate(secret_key_base, encrypted_signed_cookie_salt)
  end
end
