defmodule MicroservicesAuthorization.MixProject do
  use Mix.Project

  @version "0.1.0"
  @name "microservices_authorization"
  @maintainers ["Jad Sayegh"]
  @url "https://github.com/jsayegh/microservices_authorization"

  def project do
    [
      app: :microservices_authorization,
      version: @version,
      elixir: "~> 1.8",
      start_permanent: Mix.env() == :prod,
      test_coverage: [tool: ExCoveralls],
      preferred_cli_env: [
        coveralls: :test,
        "coveralls.detail": :test,
        "coveralls.post": :test,
        "coveralls.html": :test
      ],
      description: description(),
      package: package(),
      deps: deps(),
      name: @name,
      source_url: @url
    ]
  end

  # Run "mix help compile.app" to learn about applications.
  def application do
    [
      extra_applications: [:logger]
    ]
  end

  # Run "mix help deps" to learn about dependencies.
  defp deps do
    [
      {:ex_doc, ">= 0.0.0", only: :dev},
      {:poison, "~> 3.1"},
      {:plug, "~> 1.0"},
      {:credo, "~> 0.10.0", only: [:dev, :test], runtime: false},
      {:inch_ex, github: "rrrene/inch_ex", only: [:dev, :test], runtime: false},
      {:excoveralls, "~> 0.10", only: :test}
    ]
  end

  defp description do
    "Custom Elixir authorization library"
  end

  defp package do
    [
      # This option is only needed when you don't want to use the OTP application name 
      name: @name,
      # These are the default files included in the package 
      files: ["lib", "mix.exs", "README*", "LICENSE*"],
      maintainers: @maintainers,
      licenses: ["MIT"],
      links: %{"GitHub" => @url}
    ]
  end
end
